#include "main.h"

bool Finished()
{
	bool bRetVal = false;

	MSG msg;
	while (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	{
		if (msg.message == WM_QUIT)
		{
			bRetVal = true;
		}

		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return bRetVal;
}

void UpdateGame(float DeltaTime)
{
}

void UpdateRender(float DeltaTime)
{
	float AbsTime = gTimer->getAbsoluteTime();

	NVec2 Pos(cos(AbsTime), -sin(AbsTime));
	Pos = Pos * 64.0f;
	Pos = Pos + NVec2(128, 112);

	NBlitter::Blit(*(Globals::Backbuffer), Globals::Backdrop, 0, 0, 0, 0, 256, 224, false);
	
	Globals::Sprite.Blit(Globals::Backbuffer->getHDC(), (int)Pos.x, (int)Pos.y, 0, 0, 16, 16);

	// Text example:
	{
		static char HUDString[64];
		//int HUDStrLen = sprintf_s(HUDString, 64, "FPS: %f", (1.0f / DeltaTime));
		int HUDStrLen = sprintf_s(HUDString, 64, "Words words words");

		SetTextColor(Globals::Backbuffer->getHDC(), RGB(0,0,0));
		TextOut(Globals::Backbuffer->getHDC(), 1, 1, HUDString, HUDStrLen);
		SetTextColor(Globals::Backbuffer->getHDC(), RGB(255,255,255));
		TextOut(Globals::Backbuffer->getHDC(), 0, 0, HUDString, HUDStrLen);
	}
}

bool NeedsRender()
{
	bool bRetVal = false;

	float AbsTime = gTimer->getAbsoluteTime();
	if (AbsTime - Globals::LastRenderTime >= Globals::RENDER_THRESHOLD)
	{
		bRetVal = true;
	}

	return bRetVal;
}

void MainLoop()
{
	while (!Finished())
	{
		gTimer->update();

		if (NeedsRender())
		{
			//float DeltaTime = gTimer->getDeltaTime();
			float DeltaTime = Globals::RENDER_THRESHOLD;
			//float DeltaTime = gTimer->getAbsoluteTime() - Globals::LastRenderTime;

			Globals::LastRenderTime = gTimer->getAbsoluteTime();

			// Blit the previous frame's buffer to the window.
			{
				StretchBlt(
					GetDC(Globals::gWnd), 0, 0, Globals::GAME_WIDTH * 3, Globals::GAME_HEIGHT * 3,
					Globals::Backbuffer->getHDC(), 0, 0, Globals::GAME_WIDTH, Globals::GAME_HEIGHT,
					SRCCOPY);
			}

			// Then swap the buffers.
			if (Globals::Backbuffer == &Globals::Backbuffer1)
			{
				Globals::Backbuffer = &Globals::Backbuffer2;
			}
			else
			{
				Globals::Backbuffer = &Globals::Backbuffer1;
			}

			// Now we have a full tick's worth to update the game and draw the scene before we need to blit it.

			// Then update the game.
			UpdateGame(DeltaTime);

			// Then draw the new scene.
			UpdateRender(DeltaTime);

			// (We'll blit the newly updated frame to the window once the next threshold has been hit.)
		}

		//SwitchToThread();
		Sleep(1);
	}
}
