#include "MainWindow.h"

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_CLOSE:
		PostQuitMessage(0);
		break;

	default:
		break;
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}

HWND BuildWindow(int Width, int Height, const char* Title, HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR cmdLine, int cmdShow)
{
	WNDCLASSEX wcex;

	ZeroMemory(&wcex, sizeof(wcex));
	wcex.cbSize = sizeof(WNDCLASSEX);

	if (!GetClassInfoEx(hInst, "Main Window", &wcex))
	{
		wcex.cbSize = sizeof(WNDCLASSEX);

		wcex.style			= CS_HREDRAW | CS_VREDRAW;
		wcex.lpfnWndProc	= MainWndProc;
		wcex.cbClsExtra		= 0;
		wcex.cbWndExtra		= 0;
		wcex.hInstance		= hInst;
		wcex.hIcon			= LoadIcon(hInst, NULL);
		wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wcex.hbrBackground	= GetSysColorBrush(COLOR_WINDOW);	// COLOR_WINDOW is white.  COLOR_3DFACE will make the window gray, if I want that.
		wcex.lpszMenuName	= NULL;
		wcex.lpszClassName	= "Main Window";
		wcex.hIconSm		= LoadIcon(wcex.hInstance, NULL);

		RegisterClassEx(&wcex);
	}

	HWND hWnd = CreateWindowEx(0,		// extra window attributes
		"Main Window",						// window class name
		Title,				// title bar
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, //WS_OVERLAPPEDWINDOW,							// window style
		64,							// x
		64,							// y
		Width,			// width
		Height,			// height
		NULL,							// handle to parent window
		NULL,					// handle to menu					// 11/10/2009: OR a control identifier for buttons, etc.!!
		hInst,						// handle to window instance
		NULL);									// extra info

	ShowWindow(hWnd, cmdShow);

	return hWnd;
}
