#pragma once

#include "NWindowsVersion.h"
#include <commdlg.h>

#include <stdio.h>
#include <assert.h>
#include "NMathDefs.h"
#include "NString.h"

const int MAX_FILENAME_LENGTH = 256;

// frequently used ops, might as well wrap them
int GetFileSize(FILE* file);
int ReadFileToBuffer(FILE* file, char*& buffer);

bool FileExists(const char* filename);

void ListAllFiles(const char* basepath, const char* filter, std::vector<NString>& OutFiles, bool bIncludeSubfolders=true, const char* subfolderpath=NULL);

// Will return false if the file does not exist
bool GetChecksum(const char* filename, uint& OutSum);

// Generalizing this pattern since I use it so often.
// Could be a macro but whatever.
bool IsVersion(int InMajor, int InMinor, int TestMajor, int TestMinor);
