#pragma once

typedef unsigned char byte;
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned short ushort;

typedef unsigned long nulong;
typedef signed long nlong;
typedef size_t nsize_t;



static const float TAU	= 6.283185307179586f;
static const float PI	= 3.141592653589793f;
static const float INV_PI		= 0.318309886183791f;		// These were used for a fastsin function that I rejected
static const float INV_PI_SQ	= 0.101321183642338f;		// These were used for a fastsin function that I rejected
static const float HALF_PI		= 1.570796326794897f;
static const float TWO_PI		= TAU;
static const float HALF_TAU		= PI;

static const float E	= 2.718281828459045f;

static const float PHI	= 1.618033988749895f;
static const float INV_PHI	= 0.618033988749895f;

static const float DEG2RAD = PI / 180.0f;
static const float RAD2DEG = 180.0f / PI;

#ifdef INFINITY
#undef INFINITY
#endif

#ifdef NEG_INFINITY
#undef NEG_INFINITY
#endif

static const nulong UINT_INF = 0x7f800000;
#define INFINITY *(float*)&UINT_INF

static const nulong UINT_NEG_INF = 0xff800000;
#define NEG_INFINITY *(float*)&UINT_NEG_INF
