#include "NTimer.h"

NTimer gTimerObj;
NTimer* gTimer = &gTimerObj;

bool NTimer::init()
{
	LARGE_INTEGER counter = {0};

	if (!QueryPerformanceFrequency(&counter))
	{
		return false;
	}

	res = 1.0 / (double)counter.QuadPart;

	memset(&counter, 0, sizeof(LARGE_INTEGER));

	if (!QueryPerformanceCounter(&counter))
	{
		return false;
	}

	start = counter.QuadPart;
	current = counter.QuadPart;

	return true;
}

void NTimer::update()
{
	LARGE_INTEGER counter = {0};
	if (!QueryPerformanceCounter(&counter))
	{
		return;
	}
	
	// TODO: Use the bool multiply trick.
	if (paused)
	{
		delta = 0.0;
	}
	else
	{
		LONGLONG diff = counter.QuadPart - current;
		delta = double(diff) * res;
	}

	current = counter.QuadPart;
}

void NTimer::pause()
{
	pause(!paused);
}

void NTimer::pause(bool flag)
{
	if (flag)
	{
		LARGE_INTEGER counter = {0};
		if (!QueryPerformanceCounter(&counter))
		{
			return;
		}

		paused_at = counter.QuadPart;
	}
	else if (!flag)
	{
		LARGE_INTEGER counter = {0};
		if (!QueryPerformanceCounter(&counter))
		{
			return;
		}

		// advance start time to compensate for paused time
		// (so that the absolute time stays the same after pausing)
		unpaused_at = counter.QuadPart;
		start += (unpaused_at - paused_at);
	}

	paused = flag;
}

float NTimer::getAbsoluteTime() const
{
	return float(double(current - start) * res);
}
