#include "NVec2.h"
#include "NVec3.h"
#include "NVec4.h"
#include "NMat4.h"
#include <string.h>

#include <tchar.h>

NVec2::NVec2(const NVec3& v) : x(v.x), y(v.y) {}
NVec2::NVec2(const NVec4& v) : x(v.x), y(v.y) {}
NVec3::NVec3(const NVec2& v) : x(v.x), y(v.y), z(0.0f) {}
NVec3::NVec3(const NVec2& v, float _z) : x(v.x), y(v.y), z(_z) {}
NVec3::NVec3(const NVec4& v) : x(v.x), y(v.y), z(v.z) {}
NVec4::NVec4(const NVec2& v) : x(v.x), y(v.y), z(0.0f), w(0.0f) {}
NVec4::NVec4(const NVec2& v, float _z, float _w) : x(v.x), y(v.y), z(_z), w(_w) {}
NVec4::NVec4(const NVec3& v) : x(v.x), y(v.y), z(v.z) , w(0.0f) {}
NVec4::NVec4(const NVec3& v, float _w) : x(v.x), y(v.y), z(v.z) , w(_w) {}

NVec2 NVec2::operator *(const NMat4& m) const
{
	return m * *this;
}

NVec3 NVec3::operator *(const NMat4& m) const
{
	return m * *this;
}

NVec4 NVec4::operator *(const NMat4& m) const
{
	return m * *this;
}

void NVec2::operator *=(const NMat4& m)
{
	*this = m * *this;
}

void NVec3::operator *=(const NMat4& m)
{
	*this = m * *this;
}

void NVec4::operator *=(const NMat4& m)
{
	*this = m * *this;
}

NVec4 atov(const char* string)
{
	NVec4 retVal;

	float* farray = (float*)(&retVal);
	int i = 0;

	while (string && strlen(string) > 0 && i < 4)
	{
		farray[i++] = (float)atof(string);
		string = strstr(string, " ");
		if (string)
		{
			string = _tcsspnp(string, " ");
		}
	}

	return retVal;
};
